function a = mtimes (a, b)

  if (! isa (a, "quaternion"))
    a = quaternion (a);
  endif

  if (! isa (b, "quaternion"))
    b = quaternion (b);
  endif

  w = a.w*b.w - a.x*b.x - a.y*b.y - a.z*b.z;
  x = a.y*b.z - a.z*b.y + a.w*b.x + a.x*b.w;
  y = a.z*b.x - a.x*b.z + a.w*b.y + a.y*b.w;
  z = a.x*b.y - a.y*b.x + a.w*b.z + a.z*b.w;

  a.w = w;
  a.x = x;
  a.y = y;
  a.z = z;

endfunction